// -*- C++ -*- //

#ifndef DESWIN_H
#define DESWIN_H

class DesignWin;

#include <all_include.h>
#include <nbtab.h>
#include <libgnomecanvasmm.h>
#include <libgnomecanvasmm/polygon.h>

class DesignWin : public Gtk::Window
{
private:
  ///\ref NoteBookTab to that the \ref MapWin belongs to.
  NoteBookTab & mytab;

  Gtk::SpinButton * attraction;
  Gtk::SpinButton * propulsation;
  Gtk::SpinButton * iteration;
  Gtk::Table table;
  Gtk::Button * close_button;

  sigc::signal<void, double> signal_attraction_ch;
  sigc::signal<void, double> signal_propulsation_ch;
  sigc::signal<void, int> signal_iteration_ch;
  sigc::signal<void> close_run_pr;

  void emit_attraction();
  void emit_propulsation();
  void emit_iteration();
  void emit_closerun(){close_run_pr.emit();};

public:
  ///Close window if escape key is pressed.
  bool closeIfEscapeIsPressed(GdkEventKey* e);

  ///Constructor

  ///It builds the window.
  DesignWin(const std::string&, double, double, int, NoteBookTab & mw);

  sigc::signal<void, double> signal_attraction(){return signal_attraction_ch;};
  sigc::signal<void, double> signal_propulsation(){return signal_propulsation_ch;};
  sigc::signal<void, int> signal_iteration(){return signal_iteration_ch;};
  sigc::signal<void> close_run(){return close_run_pr;};

  void set_title(std::string);
};
#endif //DESWIN_H
